/* !---- DO NOT EDIT: This file autogenerated by com/jogamp/gluegen/JavaEmitter.java on Mon Jan 23 20:37:36 CET 2012 ----! */


package jogamp.nativewindow.jawt;

import java.nio.*;

import com.jogamp.gluegen.runtime.*;
import com.jogamp.common.os.*;
import com.jogamp.common.nio.*;
import jogamp.common.os.MachineDescriptionRuntime;

import java.security.*;
import jogamp.nativewindow.jawt.*;
import com.jogamp.common.os.Platform;
import com.jogamp.common.util.VersionNumber;

public class JAWT {

  StructAccessor accessor;

  private static final int mdIdx = MachineDescriptionRuntime.getStatic().ordinal();

  private static final int[] JAWT_size = new int[] { 24 /* ARMle_EABI */, 24 /* X86_32_UNIX */, 48 /* X86_64_UNIX */, 24 /* X86_32_MACOS */, 24 /* X86_32_WINDOWS */, 48 /* X86_64_WINDOWS */  };
  private static final int[] version_offset = new int[] { 0 /* ARMle_EABI */, 0 /* X86_32_UNIX */, 0 /* X86_64_UNIX */, 0 /* X86_32_MACOS */, 0 /* X86_32_WINDOWS */, 0 /* X86_64_WINDOWS */ };

  public static int size() {
    return JAWT_size[mdIdx];
  }

  public static JAWT create() {
    return create(Buffers.newDirectByteBuffer(size()));
  }

  public static JAWT create(java.nio.ByteBuffer buf) {
      return new JAWT(buf);
  }

  JAWT(java.nio.ByteBuffer buf) {
    accessor = new StructAccessor(buf);
  }

  public java.nio.ByteBuffer getBuffer() {
    return accessor.getBuffer();
  }

  public JAWT setVersion(int val) {
    accessor.setIntAt(version_offset[mdIdx], val, MachineDescriptionRuntime.getStatic().md.intSizeInBytes());
    return this;
  }

  public int getVersion() {
    return accessor.getIntAt(version_offset[mdIdx], MachineDescriptionRuntime.getStatic().md.intSizeInBytes());
  }

  /** Interface to C language function: <br> <code> JAWT_DrawingSurface *  GetDrawingSurface(JNIEnv *  env, jobject target); </code>    */
  public JAWT_DrawingSurface GetDrawingSurface(Object target)  {

    ByteBuffer _res;
    _res = GetDrawingSurface0(getBuffer(), target);
    if (_res == null) return null;
    return JAWT_DrawingSurface.create(Buffers.nativeOrder(_res));
  }
  /** Entry point to C language function: <code> JAWT_DrawingSurface *  GetDrawingSurface(JNIEnv *  env, jobject target); </code>    */
  private native ByteBuffer GetDrawingSurface0(ByteBuffer jthis0, Object target);

  /** Interface to C language function: <br> <code> void FreeDrawingSurface(JAWT_DrawingSurface *  ds); </code>    */
  public void FreeDrawingSurface(JAWT_DrawingSurface ds)  {

        FreeDrawingSurface0(getBuffer(), ((ds == null) ? null : ds.getBuffer()));
  }
  /** Entry point to C language function: <code> void FreeDrawingSurface(JAWT_DrawingSurface *  ds); </code>    */
  private native void FreeDrawingSurface0(ByteBuffer jthis0, ByteBuffer ds);

  /** Interface to C language function: <br> <code> void Lock(JNIEnv *  env); </code>    */
  public void Lock()  {

        Lock0(getBuffer());
  }
  /** Entry point to C language function: <code> void Lock(JNIEnv *  env); </code>    */
  private native void Lock0(ByteBuffer jthis0);

  /** Interface to C language function: <br> <code> void Unlock(JNIEnv *  env); </code>    */
  public void Unlock()  {

        Unlock0(getBuffer());
  }
  /** Entry point to C language function: <code> void Unlock(JNIEnv *  env); </code>    */
  private native void Unlock0(ByteBuffer jthis0);

  // --- Begin CustomJavaCode .cfg declarations
  /** Available and recommended on Mac OS X >= 10.6 Update 4 */
  public static final int JAWT_MACOSX_USE_CALAYER = 0x80000000;
  public static final VersionNumber JAWT_MacOSXCALayerMinVersion = new VersionNumber(10,6,4);
  
  private int jawt_version_cached = 0;
  
  public final int getCachedVersion() {
      return jawt_version_cached;
  }
  
  /** Helper routine for all users to call to access the JAWT. */
  public static JAWT getJAWT(final int jawt_version_flags) {
      JAWTUtil.initSingleton();
      // Workaround for 4845371.
      // Make sure the first reference to the JNI GetDirectBufferAddress is done
      // from a privileged context so the VM's internal class lookups will succeed.
      return AccessController.doPrivileged(new PrivilegedAction<JAWT>() {
          public JAWT run() {
            int jawt_version_flags_mod = jawt_version_flags;
            JAWT jawt = JAWT.create();
            if( 0 != ( jawt_version_flags_mod & JAWT_MACOSX_USE_CALAYER ) ) {
                jawt.setVersion(jawt_version_flags_mod);
                if (JAWTFactory.JAWT_GetAWT(jawt)) {
                    jawt.jawt_version_cached = jawt.getVersion();
                    return jawt;
                }
                jawt_version_flags_mod &= ~JAWT_MACOSX_USE_CALAYER;
                System.err.println("MacOSX "+Platform.OS_VERSION_NUMBER+" >= "+JAWT_MacOSXCALayerMinVersion+": Failed to use JAWT_MACOSX_USE_CALAYER");
            }
            jawt.setVersion(jawt_version_flags_mod);
            if (!JAWTFactory.JAWT_GetAWT(jawt)) {
              throw new RuntimeException("Unable to initialize JAWT: 0x"+Integer.toHexString(jawt_version_flags_mod));
            }
            jawt.jawt_version_cached = jawt.getVersion();
            return jawt;
          }
        });
  }
  // ---- End CustomJavaCode .cfg declarations
}
